//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Iphlpapi.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
   Memo1->Lines->Clear();


   BYTE *pbBuf1, *pbBuf2;
   ULONG ulLen1, ulLen2;
   IP_ADAPTER_INFO *pipai=NULL;   
   IP_PER_ADAPTER_INFO *pippai=NULL;
   AnsiString szTemp;
   IP_ADDR_STRING *pipas=NULL;
   if(GetAdaptersInfo(NULL, &ulLen1)!=ERROR_BUFFER_OVERFLOW)
   {
   	ShowMessage("error while get the size of Buffer Size for GetAdaptersInfo");
   	exit;
   }
   pbBuf1 = new BYTE[ulLen1];

   if(ERROR_SUCCESS==GetAdaptersInfo((IP_ADAPTER_INFO*)pbBuf1, &ulLen1))
   {
      pipai=(IP_ADAPTER_INFO*)pbBuf1;
      do
      {
         //---------------------------------------------------------------------
         // Name
         Memo1->Lines->Add("AdapterName="+(AnsiString)pipai->AdapterName);

         //---------------------------------------------------------------------
         // Description
         Memo1->Lines->Add("Description="+(AnsiString)pipai->Description);

         //---------------------------------------------------------------------
         // Mac ID
         szTemp.sprintf("%02X:%02X:%02X:%02X:%02X:%02X",
            pipai->Address[0], pipai->Address[1], pipai->Address[2],
            pipai->Address[3], pipai->Address[4], pipai->Address[5]);
         Memo1->Lines->Add("Address="+szTemp);

         //---------------------------------------------------------------------
         // Interface index
         Memo1->Lines->Add("Index="+IntToStr(pipai->Index));

         //---------------------------------------------------------------------
         // Adapter type
         Memo1->Lines->Add("Type="+IntToStr(pipai->Type));

         //---------------------------------------------------------------------
         // DHCP is enabled or not
         Memo1->Lines->Add("DhcpEnabled="+IntToStr(pipai->DhcpEnabled));

         //---------------------------------------------------------------------
         // IP address
         pipas=&(pipai->IpAddressList);
         while(pipas!=NULL)
         {
            Memo1->Lines->Add("IpAddressList="+(AnsiString)pipas->IpAddress.String);
            pipas=pipas->Next;
         }

         //---------------------------------------------------------------------
         // IP mask
         Memo1->Lines->Add("IpMask="+(AnsiString)pipai->IpAddressList.IpMask.String);

         //---------------------------------------------------------------------
         // Gateway
         pipas=&(pipai->GatewayList);
         while(pipas!=NULL)
         {
            Memo1->Lines->Add("GatewayList="+(AnsiString)pipas->IpAddress.String);
            pipas=pipas->Next;
         }

         //---------------------------------------------------------------------
         // DHCP server address
         Memo1->Lines->Add("DhcpServer="+(AnsiString)pipai->DhcpServer.IpAddress.String);
         
         if(GetPerAdapterInfo(pipai->Index, NULL, &ulLen2)!=ERROR_BUFFER_OVERFLOW)
         {
   	    ShowMessage("error while get the size of Buffer Size for GetPerAdapterInfo");
   	    exit;         	
         }
         pbBuf2 = new BYTE[ulLen2];

         if(ERROR_SUCCESS==GetPerAdapterInfo(pipai->Index, (IP_PER_ADAPTER_INFO*)pbBuf2, &ulLen2))
         {
            pippai=(IP_PER_ADAPTER_INFO*)pbBuf2;
            Memo1->Lines->Add("AutoconfigEnabled="+IntToStr(pippai->AutoconfigEnabled));
            Memo1->Lines->Add("AutoconfigActive="+IntToStr(pippai->AutoconfigActive));

            //------------------------------------------------------------------
            // DNS server address
            pipas=&(pippai->DnsServerList);
            while(pipas!=NULL)
            {
               Memo1->Lines->Add("DnsServerList="+(AnsiString)pipas->IpAddress.String);
               pipas=pipas->Next;
            }
         }
         
         delete[] pbBuf2;

         //---------------------------------------------------------------------
         // Have wins or not
         szTemp=(pipai->HaveWins)? "true": "false";
         Memo1->Lines->Add("HaveWins="+szTemp);

         //---------------------------------------------------------------------
         // Primary wins server address
         Memo1->Lines->Add("PrimaryWinsServer="+(AnsiString)pipai->PrimaryWinsServer.IpAddress.String);

         //---------------------------------------------------------------------
         // Secondary wins server address
         Memo1->Lines->Add("SecondaryWinsServer="+(AnsiString)pipai->SecondaryWinsServer.IpAddress.String);
         Memo1->Lines->Add("");

         pipai=pipai->Next;
         
      } while(pipai!=NULL);
   }
   
   delete[] pbBuf1;
}
//---------------------------------------------------------------------------

